#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef enum {integer, real, string} Type;

int N1,P1,Q1;
int N2,P2,Q2;
int S1,S2;
int R1,R2;
int Score,s;
char a[1001][21];

int freadline(Type t, FILE *f, char *b, int size)
{int i;
 char *e;
 b[0]=0;
 fgets(b,size,f);
 for (i=0;i<size&&b[i]&&b[i]!='\n';i++);
 b[i]=0;
 switch (t)
 {case string:return 1;
  case integer:{strtol(b,&e,10);
		return *b&&!*e;
	       }
  case real:{strtod(b,&e);
	     return *b&&!*e;
	    }
 }
 return 0;
}

int getInput(FILE *f,int *a, int *b, int *c)
{char buf[32];
 if (!freadline(string,f,buf,30)) return 0;
 if (sscanf(buf,"%d %d %d",a,b,c)!=3) return 0;
 return 1;
}

void init(int P, int Q)
{int i;
 for (i=0;i<P;i++)
  memset(a[i],0,Q+1);
}

char getMove(int P, int Q, int n, int last)
{int i;
 for (i=Q;i>=P;i--) if (i!=last && n-i>=0 && !a[n-i][i]) return i;
 return 0;
}

int makeTable(int N, int P, int Q)
{int i,j;
 init(P,Q);
 for (i=P;i<=N;i++)
 {a[i][0]=getMove(P,Q,i,0);
  for (j=P;j<=Q;j++) a[i][j]=getMove(P,Q,i,j);
 }
 return a[N][0];
}

int main(int argc, char **argv)
{FILE *fin, *fcomp;
 char buf[32];
 if (argc!=4)
 {printf("Argument error\n");
  return 0;
 }
 if (!(fin = fopen(argv[1], "r")))      // input file
 {printf("Cannot open input.\n");
  return 0;
 }
 if (!getInput(fin,&N1,&P1,&Q1))
 {printf("Wrong input.\n");
  fclose(fin);
  return 0;
 }
 if (!getInput(fin,&N2,&P2,&Q2))
 {printf("Wrong input.\n");
  fclose(fin);
  return 0;
 }
 fclose(fin);
 if (!(fcomp = fopen(argv[2], "r")))    // competitor file
 {printf("0\nCannot open result.\n");
  return 0;
 }
 if (!freadline(integer,fcomp,buf,6)) Score=0;
 else {R1=atoi(buf);
       if (R1&&(R1<P1||R1>Q1))
       {printf("0\nWrong answer.\n");
        fclose(fcomp);
        return 0;
       }
       S1=makeTable(N1,P1,Q1);
       if (R1==S1) Score=5;
       else if (!a[N1-R1][R1]) Score=3;
            else Score=0;
      }
 if (!Score){printf("0\nWrong answer.\n");
             fclose(fcomp);
             return 0;
            }
 if (!freadline(integer,fcomp,buf,6)) s=0;
 else {R2=atoi(buf);
       if (R2&&(R2<P2||R2>Q2))
       {printf("0\nWrong answer.\n");
        fclose(fcomp);
        return 0;
       }
       S2=makeTable(N2,P2,Q2);
       if (R2==S2) s=5;
       else if (!a[N2-R2][R2]) s=3;
            else s=0;
 }
 if (!s){printf("0\nWrong answer.\n");
         fclose(fcomp);
         return 0;
        }
 fclose(fcomp);
 Score+=s;
 printf("%d\n",Score);
 if(Score<8) printf("Both not optimal\n");
 else if (Score<10) printf("The one not optimal\n");
      else printf("Correct\n");
 return 0;
}
